#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

const size_t MAXN = 100000;

int N, C;
int A[MAXN];

int F(int d){
   // prev :: location of previously placed cow (initially -INF)
   // rem..:: how many cows we should still place.
   int prev = -A[N-1], remaining = C;
   for (int i = 0; i!=N; i++){
      // If the next candidate stall is further than d units 
      // from the previously placed cow, then we assign a cow.      
      if (A[i] - prev >= d) {
         prev = A[i];
         remaining--;
      }
      // If there are no cows remaining, we are done.
      if (remaining == 0) return true;
   }
   // If there are still cows, then it is not possible.
   return false;
}

int main(){
   int T;
   scanf("%d", &T);
   while(T--) {
   scanf("%d%d", &N, &C);
   for (int i = 0; i<N; i++) scanf("%d", &A[i]);
   // Sort the stalls.
   sort(A, A+N);
   // Binary search.
   int st = 0, en = A[N-1] - A[0], mn;
   while(st < en){
      mn = (st+en+1)/2;
      if (F(mn) == true) st = mn;
      else en = mn - 1;
   }
   printf ("%d\n", st);
   }
   return 0;
}
