class Solution {
    
    public int find_upper(int[] nums, int target) {
        if (nums.length == 0) return -1;
        int st = 0, en = nums.length - 1;
        while (st < en) {
            // There is a subtle change here. 
            // If we are left with just two elements, say [t; t], 
            // mn = (st + en)/2 = 0. But looking at the first element,
            // we would not discard it (and would lead to an infinite loop).
            // Looking at the second element allows to discard the first one.
            // and this is what mn = (st + en + 1)/2 = 1 suggests.
            int mn = (st + en + 1) / 2;
            if (nums[mn] > target) en = mn - 1;
            else st = mn;
        }
        if (nums[st] == target) return st;
        return -1;
    }
    
    public int find_lower(int[] nums, int target) {
        if (nums.length == 0) return -1;
        int st = 0, en = nums.length - 1;
        while (st < en) {
            int mn = (st + en) / 2;
            if (nums[mn] < target) st = mn + 1;
            else en = mn;
        }
        if (nums[st] == target) return st;
        return -1;
    }
    
    public int[] searchRange(int[] nums, int target) {
        return new int[]{find_lower(nums, target), find_upper(nums, target)};
    }
}
