import numpy as np
import scipy.optimize

x = np.linspace(20, 29, 10)
y = [0.047000, 0.093000, 0.182000, 0.365000, 0.747000, 1.538000, 3.241000, 6.069000, 11.855000, 23.787000]


def pred(a, v):
    return a * np.power(2.0, v)


def log_likelihood(a):
    diff = pred(a, x) - y
    return np.sum(diff * diff)


coeffs = scipy.optimize.fmin(log_likelihood, np.array([0.04]))
preds = pred(coeffs, x)
for (xx, yy) in zip(x, preds):
    print(f"({xx}, {yy})")
print(f"{coeffs[0]} * 2^x")
