import java.util.ArrayList;
import java.util.Collections;

public class SortingPairs {
	
	public static class NameAndId implements Comparable<NameAndId> {
		String name;
		int id;
		
		public NameAndId(String name, int id) {
			this.name = name;
			this.id = id;
		}
		
		@Override
		public int compareTo(NameAndId other) {
			if (name == other.name) return Integer.compare(id, other.id);
			return name.compareTo(other.name);
		}
		
		@Override
		public String toString() {
			return "(" + name + ", " + id + ")";
		}
	}
	
	public static void main(String[] args) {
		ArrayList<NameAndId> arr = new ArrayList<>();
		arr.add(new NameAndId("Bob", 14));
		arr.add(new NameAndId("Bob", 17));
		arr.add(new NameAndId("Bob", 12));
		arr.add(new NameAndId("Alice", 19));
		arr.add(new NameAndId("Thomas", 14));
		arr.add(new NameAndId("Alice", 11));
		Collections.sort(arr);
		for (NameAndId v : arr) {
			System.out.println(v);
		}
	}

}
